//-- przejazd z sygnalizacja swietlna na linii dwutorowej. 

// p1 - nazwa przejazdu, p2,p3,p4-polozenie,p5-rotacja, p6,p7 - nazwa drogi przed i za przejazdem, p8,p9 - nazwy torow przebiegajacych przez przejazd
origin (p2) (p3) (p4)
rotate 0 (p5) 0

//UWAGA - POPRAWIC WSPOLRZEDNE!

//--- modele sygnalizacji przejazdowej 
node 500 0 (p1)_Syg1 model 4.0 0.0 -8.0 -90 SP2ccXX.t3d Lights 1 0 endmodel
node 500 0 (p1)_Syg2 model -4.0 0.0 7.0 90 SP2ccXX.t3d Lights 1 0 endmodel
// uwaga na trik - jedno swiatlo ma zamienione nazwy On z Off, dzieki czemu beda migac na zmiane!

//--- komorki do wysylania informacji o predkosci dla samochodow
node -1 0 (p1)_syg1_mem memcell (p2) (p3) (p4) SetVelocity -1 -1 (p6) endmemcell
node -1 0 (p1)_syg2_mem memcell (p2) (p3) (p4) SetVelocity -1 -1 (p7) endmemcell
node -1 0 (p1)_syg_distmem memcell (p2) (p3) (p4) SetVelocity -1 20.0 none endmemcell

//zdarzenia wysylajace informacje dla samochodow:
//--- to zdarzenie powinno byc podpiete jako event1 do drogi (p6)
event (p1)_syg1_info getvalues 1.0 (p1)_syg1_mem endevent
//--- to zdarzenie powinno byc podpiete jako event2 do drogi (p7)
event (p1)_syg2_info getvalues 1.0 (p1)_syg2_mem endevent
//--- to zdarzenie powinno byc podpiete jako event1 do odcinka 100m przed przejazdem i jako event2 do odcinka za przejazdem
event (p1)_syg_distinfo getvalues 2.0 (p1)_syg_distmem endevent

//elementarne zdarzenia:

//--- migajace lampki
event (p1)_0_sygn1 lights 0.8 (p1)_Syg1 2 2 endevent
event (p1)_0_sygn2 lights 0.8 (p1)_Syg2 2 2 endevent
//--- zgaszone lampki
event (p1)_1_sygn1 lights 0.8 (p1)_Syg1 1 0 endevent
event (p1)_1_sygn2 lights 0.8 (p1)_Syg2 1 0 endevent

//-- dzwiek dzwonu przejazdowego (na razie nie dziala)
//event (p1)_bell1 sound 0 trabka.wav 200 (p2) (p3) (p4) 1
// zdarzenie wyzwalane jest co sekunde (bo czas ujemny) pod warunkiem ze przejazd jest zamkniety:
//event (p1)_bells multiple -1 (p1)_syg_distmem memcell (p1)_bell1 conditional SetVelocity 30 0

// wpisywanie informacji o tym ze przejazd zostal zamkniety:
//--- zatrzymywanie pojazdow drogowych (z opoznieniem 10s zeby zdazyly uciec z przejazdu)
event (p1)_stop1 updatevalues 10.0 (p1)_syg1_mem SetVelocity 0 0 endevent
event (p1)_stop2 updatevalues 11.0 (p1)_syg2_mem SetVelocity 0 0 endevent
//--- informacja dla pojazdow drogowych zeby hamowaly bo przejazd zamkniety:
event (p1)_dist_stop updatevalues 0.0 (p1)_syg_distmem SetVelocity 30 0 endevent

//wpisywanie informacji o tym ze przejazd zostal otwarty:
event (p1)_go1 updatevalues 1.0 (p1)_syg1_mem SetVelocity -1 -1 endevent
event (p1)_go2 updatevalues 3.0 (p1)_syg2_mem SetVelocity -1 -1 endevent
event (p1)_dist_go updatevalues 1.0 (p1)_syg_distmem SetVelocity -1 40 endevent

// globalne procedury sterujace:
//--- zamykanie przejazdu - musi byc podpiete jako event1 do torow (z kazdego kierunku) daleko przed przejazdem 
// oraz do toru na samym przejezdzie (zabezpieczenie na wypadek mijania sie 2 pociagow!)
event (p1)_zamykaj multiple 0.0 none (p1)_stop1 (p1)_stop2 (p1)_dist_stop (p1)_0_sygn1 (p1)_0_sygn2 endevent
//---otwieranie przejazdu - zdarzenia musza byc podpiete jako event1 do torow tuz za przejazdem (dla kazdego kierunku)
event (p1)_otwieraj1 multiple 2.0 (p8) (p1)_go1 (p1)_go2 (p1)_dist_go (p1)_1_sygn1 (p1)_1_sygn2 condition trackfree endevent
event (p1)_otwieraj2 multiple 2.0 (p9) (p1)_go1 (p1)_go2 (p1)_dist_go (p1)_1_sygn1 (p1)_1_sygn2 condition trackfree endevent

// komentarz: ostatnie zdarzenia otwieraj* sa warunkowe (conditional) - wyzwalane jest przez najechanie pojazdu na tor
// za przejazdem ale tylko gdy tor o nazwie (p1) ktory jest na przejezdzie bedzie wolny.

rotate 0 0 0
endorigin